'use strict';

/* Controllers */

angular.module('myApp.controllers', [])
.controller('MyCtrl1', ['$scope','$rootScope','myService',function($scope,$rootScope,myService) {
                        //controller code goe shere
                        //
                        var resizeListener = $rootScope.$watch('height',function(newVal,oldVal){
                                                               
                              document.getElementById('entirePage').style.height = $rootScope.height + 'px';
                              document.getElementById('whiteBannerMenu').style.height = ($rootScope.height * 0.09) + 'px';
                              document.documentElement.style.fontSize = ($rootScope.height * 0.03) + 'px';
                                          },true);
						//destroys event listener i think
						$scope.$on('$destroy', function() {
							resizeListener();
                                   });
                        if(!myService.isUnsupported)
						{// have this check so the home screen isn't spammed by messages everytime someone with an unsupported phone goes to it
							myService.activateSDK();
						}
                        
                        }])
.controller('MyCtrl2', ['$scope','$rootScope','dbService','$routeParams','$location', function($scope,$rootScope,dbService,$routeParams,$location) {
                        //controller code goes here
                        //
                        var menuIcon = document.getElementById('ordersIcon');
                        menuIcon.style.borderBottom = "5px solid #78aedb";
                        //resize
                        var resizeListener = $rootScope.$watch('height',function(){
                        document.getElementById('container').style.height = ($rootScope.height * (1-0.095)) + 'px';
                        //document.getElementById('entirePage').style.height = $rootScope.height + 'px';
                        //document.getElementById('whiteBannerMenu').style.height = ($rootScope.height * 0.09) + 'px';
                        //alert($rootScope.height);
                        //document.getElementById('amount2').style.height = ($rootScope.height * 0.11) + 'px';
                        document.getElementById('whiteBannerMenu').style.height = ($rootScope.height * 0.09) + 'px';
						$scope.rowHeight = ($rootScope.height * 0.14) + 'px';
                        document.documentElement.style.fontSize = ($rootScope.height * 0.03) + 'px';
						document.getElementById('entirePage').style.height = 'auto';
                        /*var elements = document.getElementsByClassName('orderRow');
                         for(i=0;i<elements.length;i++)
                         {
                         elements[i].style.height = rowHeight;
                         }
                         */
                                          });
                        $scope.orders = [{orderId:'Loading..',customerName:'Loading..'}];
                        //database stuff
                        dbService.queryDB('select id,orderid,customername,subtotal,time from orders')
                        .then(function(results) {
                              $scope.orders = results;
                              }, function(result) {
                              navigator.notification.alert('Error receiving query results.',null,'Oops','Continue');
                              });
                        
                        $scope.go = function(orderId)
                        {
                        //document.getElementById('ordersView').style.display = 'none';
                        $location.path('/view5/' + orderId);
                        }
                        //runs when the $scope is destroyed aka when leaving page
                        $scope.$on('$destroy', function() {
                                   resizeListener();//each page has a unique resize function
                                   menuIcon.style.borderBottom = "none";
                                   });
                        
                        }])
.controller('MyCtrl3', ['$scope','$rootScope', '$window','myService','ajaxService','dbService','$location', function($scope,$rootScope,$window,myService,ajaxService,dbService,$location) {
                        //controller code goes here
                        //
                        var menuIcon = document.getElementById('purchaseIcon');
                        menuIcon.style.borderBottom = "5px solid #78aedb";
                        var addedFields = false;
                        myService.modalActivated = false;
                        
                        
                        var resizeListener = $rootScope.$watch('height',function(){
                        //document.getElementById('whiteBannerMenu').style.height = (height * 0.09) + 'px';
                        document.getElementById('whiteBannerMenu').style.height = ($rootScope.height * 0.09) + 'px';
                        document.getElementById('container').style.height = ($rootScope.height * (1-0.095)) + 'px';
                        document.getElementById('amount').style.height = ($rootScope.height * 0.16) + 'px';
                        document.getElementById('cardNum').style.height = ($rootScope.height * 0.13) + 'px';
                        document.getElementById('customer').style.height = ($rootScope.height * 0.13) + 'px';
                        document.getElementById('email').style.height = ($rootScope.height * 0.13) + 'px';
                        //document.getElementById('spaceOrderNotes').style.height = (height * 0.01) + 'px';
                        document.getElementById('lineOrderNotes').style.height = ($rootScope.height * 0.16) + 'px';
                        document.getElementById('spaceBottomButtons').style.height = ($rootScope.height * 0.04) + 'px';
                        document.getElementById('buttonsLine').style.height = ($rootScope.height * 0.08) + 'px';
                        //document.getElementById('spaceBottomButtons').style.height = (height * 0.03) + 'px';
                                                               var rootHtml = document.documentElement;
                                                               rootHtml.style.fontSize = ($rootScope.height * 0.03) + 'px';
                        //document.getElementById('inputAmount').style.fontSize = (height * 0.10) + 'px';
                        document.getElementById('additional1').style.height = ($rootScope.height * 0.14) + 'px';
                        document.getElementById('additional2').style.height = ($rootScope.height * 0.14) + 'px';
                        document.getElementById('additional3').style.height = ($rootScope.height * 0.14) + 'px';
						document.getElementById('entirePage').style.height = 'auto';
                                          });
                        
                        //detect if there's an internet connection
                        
                        
                        var canada = new Array(
                                               '',
                                               'Alberta',
                                               'British Columbia',
                                               'Manitoba',
                                               'New Brunswick',
                                               'Newfoundland',
                                               'Northwest Territories',
                                               'Nova Scotia',
                                               'Nunavut',
                                               'Ontario',
                                               'Prince Edward Island',
                                               'Quebec',
                                               'Saskatchewan',
                                               'Yukon Territory'
                                               );
                        
                        var usa = new Array(
                                            '',
                                            'Alabama',
                                            'Alaska',
                                            'Arizona',
                                            'Arkansas',
                                            'California',
                                            'Colorado',
                                            'Connecticut',
                                            'Delaware',
                                            'District of Columbia',
                                            'Florida',
                                            'Georgia',
                                            'Hawaii',
                                            'Idaho',
                                            'Illinois',
                                            'Indiana',
                                            'Iowa',
                                            'Kansas',
                                            'Kentucky',
                                            'Louisiana',
                                            'Maine',
                                            'Maryland',
                                            'Massachusetts',
                                            'Michigan',
                                            'Minnesota',
                                            'Mississippi',
                                            'Missouri',
                                            'Montana',
                                            'Nebraska',
                                            'Nevada',
                                            'New Hampshire',
                                            'New Jersey',
                                            'New Mexico',
                                            'New York',
                                            'North Carolina',
                                            'North Dakota',
                                            'Ohio',
                                            'Oklahoma',
                                            'Oregon',
                                            'Pennsylvania',
                                            'Puerto Rico',
                                            'Rhode Island',
                                            'South Carolina',
                                            'South Dakota',
                                            'Tennessee',
                                            'Texas',
                                            'Utah',
                                            'Vermont',
                                            'Virginia',
                                            'Virgin Islands',
                                            'Washington',
                                            'West Virginia',
                                            'Wisconsin',
                                            'Wyoming'
                                            );
                        //addedFields = false;//hack for resizing
                        $scope.provinces = canada;
                        $scope.expYears = [];
                        $scope.amount = '';
                        $scope.cardNum = '';
                        $scope.expMonth = '';
                        $scope.expYear = '';
                        $scope.customerName = '';
                        $scope.cvv = '';
                        $scope.email = '';
                        $scope.orderNotes = '';
                        $scope.phone = '';
                        $scope.city = '';
                        $scope.address = '';
                        $scope.province = '';
                        $scope.postal = '';
                        $scope.country = '';
                        $scope.cardAction = '0';
                        
                        
                        
                        if(myService.isReaderConnected)
                        {
                        document.getElementById('btnSwipe').disabled = false;
                        document.getElementById('btnSwipe').style.background = "#a0c6e6";
                        document.getElementById('btnSwipe').style.color = "#fff";
                        document.getElementById('btnSwipe').style.border = "1px solid #a0c6e6";
                        document.getElementById('btnSwipe').style.opacity = "1.0";
                        }
                        
                        //load current years into card expiry <select>
                        var currentYear = new Date().getFullYear();
                        for(var i=0;i<10;i++)
                        {
                        $scope.expYears.push((i + currentYear).toString().substring(0,4));
                        }
                        
                        function testModeConfirm(buttonIndex)
                        {
                            if(buttonIndex == 1)
                            {
                                var xmlString = "<Order>"
                        + "<OrderId>" + $scope.orderId + "</OrderId>"
                                //customer details (optional)
                                + "<Bname>" + encodeURI($scope.customerName) + "</Bname>"
                                + "<Email>" + $scope.email + "</Email>"
                                + "<Baddress1>" + $scope.address + "</Baddress1>"
                                + "<Bcity>" + encodeURI($scope.city) + "</Bcity>"
                                + "<Bprovince>" + encodeURI($scope.province) + "</Bprovince>"
                                +"<Bpostalcode>" + encodeURI($scope.postal) + "</Bpostalcode>"
                                +"<Bcountry>" + encodeURI($scope.country) + "</Bcountry>"
                                +"<Phone>" + encodeURI($scope.phone) + "</Phone>"
                                +"<Comments>" + $scope.orderNotes + "</Comments>"
                                //card and transaction details (required)
                                +"<StoreID>" + "teststore" + "</StoreID>"
                                +"<Passphrase>" + "psigate1234" + "</Passphrase>"
                                +"<PaymentType>" + "CC" + "</PaymentType>"
                                +"<CardAction>" + $scope.cardAction + "</CardAction>"
                                +"<Subtotal>" + $scope.amount + "</Subtotal>"
                                +"<CardNumber>" + $scope.cardNum + "</CardNumber>"
                                +"<CardExpMonth>" + $scope.expMonth + "</CardExpMonth>"
                                +"<CardExpYear>" + $scope.expYear.substring(2,4) + "</CardExpYear>"
                                +"<CardIDNumber>" + $scope.cvv + "</CardIDNumber>"
                                
                                + "</Order>";
                        
                            }
                            else if (buttonIndex == 2)
                            {
                                $location.path('/view4/');
                            }
                            else
                            {
                                return null;
                            }
                        }
                        
                        $scope.process = function()
                        {
                        
                        if(validateNumber($scope.amount.toString()))
                        {
                        if($scope.cardNum.toString().length == 16)
                        {
                        if($scope.expYear && $scope.expMonth)
                        {
                        var element = document.getElementById('adFieldsContainer');
                        element.style.display = 'none';
                        document.getElementById('buttonsLine').style.paddingBottom = '0em';
                        addedFields = false;
                        
                        myService.toggleModal('process');
                        
                        if(localStorage["testMode"] == "on")
                        {
                        navigator.notification.confirm('You are currently in Test mode, so no real money is being exchanged. Go Live by visiting the Options page.',function(buttonIndex) {
                                   if(buttonIndex == 1)
                                   {
                                                       
                                       //create XML string
                                       var d = new Date();
                                       var month = "0" + d.getMonth();
                                       var day = "0" + d.getDate();
                                       var hour = "0" + d.getHours();
                                       var minute = "0" + d.getMinutes();
                                       var second = "0" + d.getSeconds();
                                       $scope.orderId = d.getFullYear().toString().slice(-2) + month.slice(-2) + day.slice(-2) + hour.slice(-2) + minute.slice(-2) + second.slice(-2);
                                       var formFields = [];
                                       var xmlString = "<Order>"
                                       + "<OrderId>" + $scope.orderId + "</OrderId>"
                                       //customer details (optional)
                                       + "<Bname>" + encodeURI($scope.customerName) + "</Bname>"
                                       + "<Email>" + $scope.email + "</Email>"
                                       + "<Baddress1>" + $scope.address + "</Baddress1>"
                                       + "<Bcity>" + encodeURI($scope.city) + "</Bcity>"
                                       + "<Bprovince>" + encodeURI($scope.province) + "</Bprovince>"
                                       +"<Bpostalcode>" + encodeURI($scope.postal) + "</Bpostalcode>"
                                       +"<Bcountry>" + encodeURI($scope.country) + "</Bcountry>"
                                       +"<Phone>" + encodeURI($scope.phone) + "</Phone>"
                                       +"<Comments>" + $scope.orderNotes + "</Comments>"
                                       //card and transaction details (required)
                                       +"<StoreID>" + "teststore" + "</StoreID>"
                            +"<Passphrase>" + "psigate1234" + "</Passphrase>"
                                       +"<PaymentType>" + "CC" + "</PaymentType>"
                                       +"<CardAction>" + $scope.cardAction + "</CardAction>"
                                       +"<Subtotal>" + $scope.amount + "</Subtotal>"
                                       +"<CardNumber>" + $scope.cardNum + "</CardNumber>"
                                       +"<CardExpMonth>" + $scope.expMonth + "</CardExpMonth>"
                                       +"<CardExpYear>" + $scope.expYear.substring(2,4) + "</CardExpYear>"
                                       +"<CardIDNumber>" + $scope.cvv + "</CardIDNumber>"
                                       
                                       + "</Order>";
                                        sendOrder(xmlString,false);
                                   
                                   }
                                   else if (buttonIndex == 2)
                                   {
                                        myService.toggleModal('process');
                                                       $rootScope.$apply(function(){$location.path('/view4/')});
                                   }
                                    else
                                   {
                                       myService.toggleModal('process');
                                   }
                                                       },'F.Y.I',['Continue in Test Mode','Options','Cancel']);
                        }
                        else
                        {
                            //create XML string
                            var d = new Date();
                            var month = "0" + d.getMonth();
                            var day = "0" + d.getDate();
                            var hour = "0" + d.getHours();
                            var minute = "0" + d.getMinutes();
                            var second = "0" + d.getSeconds();
                            $scope.orderId = d.getFullYear().toString().slice(-2) + month.slice(-2) + day.slice(-2) + hour.slice(-2) + minute.slice(-2) + second.slice(-2);
							var formFields = [];
                            var xmlString = "<Order>"
							+ "<OrderId>" + $scope.orderId + "</OrderId>"
                            //customer details (optional)
                            + "<Bname>" + encodeURI($scope.customerName) + "</Bname>"
                        + "<OrderId>" + $scope.orderId + "</OrderId>"
                            + "<Email>" + $scope.email + "</Email>"
                            + "<Baddress1>" + $scope.address + "</Baddress1>"
                            + "<Bcity>" + encodeURI($scope.city) + "</Bcity>"
                            + "<Bprovince>" + encodeURI($scope.province) + "</Bprovince>"
                            +"<Bpostalcode>" + encodeURI($scope.postal) + "</Bpostalcode>"
                            +"<Bcountry>" + encodeURI($scope.country) + "</Bcountry>"
                            +"<Phone>" + encodeURI($scope.phone) + "</Phone>"
                            +"<Comments>" + $scope.orderNotes + "</Comments>"
                            //card and transaction details (required)
                            +"<StoreID>" + localStorage["storeId"] + "</StoreID>"
                            +"<Passphrase>" + localStorage["storePassword"] + "</Passphrase>"
                            +"<PaymentType>" + "CC" + "</PaymentType>"
                            +"<CardAction>" + $scope.cardAction + "</CardAction>"
                            +"<Subtotal>" + $scope.amount + "</Subtotal>"
                            +"<CardNumber>" + $scope.cardNum + "</CardNumber>"
                            +"<CardExpMonth>" + $scope.expMonth + "</CardExpMonth>"
                            +"<CardExpYear>" + $scope.expYear.substring(2,4) + "</CardExpYear>"
                            +"<CardIDNumber>" + $scope.cvv + "</CardIDNumber>"
                            
                            + "</Order>";
                        
                            sendOrder(xmlString,true);
                        }
                        }
                        else
                        {
                        navigator.notification.alert('Confirm the expiration date.',null,'Oops','Ok');
                        }
                        }
                        else
                        {
                        navigator.notification.alert('Confirm the credit card number.',null,'Oops','Ok');
                        }
                        }
                        else
                        {
                            navigator.notification.alert('Confirm the transaction amount.',null,'Oops','Ok');
                        }
                        
                        }
                        
                        function sendOrder(xmlString,isLive)
                        {
                            //Send xml request to psigate and process respond
                            ajaxService.purchaseRequest(xmlString,isLive)
                            .then(function(response) {
                                  if($(response).find('Approved').text() == "APPROVED")
                                  {
                                  var transTime = new Date($(response).find('TransTime').text()); //Date() object created from TransTime
                                  //TODO: if transtype == Sale, vs refund
                                  var newOrder = {};
                                  newOrder.status = $(response).find('Approved').text();
                                  newOrder.avsResponse = $(response).find('AVSResult').text();
                                  newOrder.refNum = $(response).find('TransRefNumber').text();
                                  newOrder.cvvResult = $(response).find('CardIDResult').text();
                                  newOrder.authAmount = $(response).find('SubTotal').text();
                                  newOrder.time = transTime.getTime(); // converts to int, number of seconds since some day in 1970 (standard unit of time measurement. easily convertable)
                                  //newOrder.transType = 'Sale';
                                  newOrder.customerName = $scope.customerName;
                                  $scope.orderId = $(response).find('OrderID').text();
                                  newOrder.orderId = $scope.orderId;
                                  newOrder.phone = $scope.phone;
                                  newOrder.email = $scope.email;
                                  newOrder.address = $scope.address;
                                  newOrder.city = $scope.city;
                                  newOrder.province = $scope.province;
                                  newOrder.country = $scope.country;
                                  newOrder.postal = $scope.postal;
                                  newOrder.notes = $scope.orderNotes;
                                  newOrder.cardAction = $scope.cardAction;
								  //check if testmode and save that value into database, or just check if testmode is active at time of refund/post-auth and disallow
                                  
                                  //add order transaction to database
                                  var sqlString = 'INSERT INTO ORDERS (orderId,customerName,email,city,phone,province,country,address,postal,subTotal,time,notes,avsResponse,refNum,cvvResult) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)';
                                  dbService.newPurchase(sqlString,newOrder)
                                  .then(function(response) {
                                        //success response from db
                                        var sqlString = 'INSERT INTO TRANSACTIONS (orderId, subTotal, time, action, status) VALUES (?,?,?,?,?)';
                                        dbService.newTransaction(sqlString,newOrder)
                                        .then(function(response) {
                                              //success for transaction db
                                              $location.path('/view5/' + $scope.orderId);
                                              },function(response) {
                                              //fail response from db
                                              navigator.notification.alert('Money received, but error while recording details on device.',null,'Oops','Continue');
                                              myService.toggleModal('process');
                                              });
                                        },function(response) {
                                        //fail response from db
                                        navigator.notification.alert('Money received, but error while recording details on device.',null,'Oops','Continue');
                                        myService.toggleModal('process');
                                        });
                                  
                                  }
                                  else
                                  {
								  console.log(response);
                                  navigator.notification.alert('Transaction not successful: ' + $(response).find('ErrMsg').text() + $(response).find('ReturnCode').text() ,null,'Oops','Continue');
                                  myService.toggleModal('process');
                                  }
                                  }, function(response) {
                                  navigator.notification.alert('Error receiving AJAX response.',null,'Oops','Continue');
                                  myService.toggleModal('process');
                                  });
                        }
                        
                        $scope.cancelModal = function(action) { myService.toggleModal(action);myService.stopTask();};
                        
                        $scope.addedFields = function() {
                        var element = document.getElementById('adFieldsContainer');
                        if(!addedFields)
                        {
                        element.style.display = 'initial';
                        document.getElementById('container').style.height = 'auto';
                        document.getElementById('buttonsLine').style.paddingBottom = '3em';
                        addedFields = true;
                        }
                        else
                        {
                        element.style.display = 'none';
                        //document.getElementById('container').style.height = (height * (1-0.095)) + 'px';
                        document.getElementById('buttonsLine').style.paddingBottom = '0em';
                        addedFields = false;
                        var height = $(window).height();
                        var width = $(window).width();
                        if(height<475)
                        {
                        height = 475;
                        }
                        
                        document.getElementById('lineOrderNotes').style.height = (height * 0.16) + 'px';
                        document.getElementById('spaceBottomButtons').style.height = (height * 0.04) + 'px';
                        document.getElementById('buttonsLine').style.height = (height * 0.08) + 'px';
                        
                        //resize();
                        }
                        }
                        
                        $scope.swipe = function()	{
                        myService.toggleModal('swipe');
                        myService.swipe()
                        .then(function(result) {
                              $scope.cardNum = parseInt(result.cardNum);
                              $scope.customerName = result.customer;
                              $scope.expMonth = result.expMonth;
                              $scope.expYear = result.expYear;
                              myService.toggleModal('swipe');
                              }, function(result) {
                              navigator.notification.alert('Error reading card: no data.',null,'Oops','Continue');
                              myService.toggleModal('swipe');
                              });
                        };
                        
                        $scope.countryChanged = function(country)
                        {
                            if(country == "United States")
                            {
                                $scope.provinces = usa;
                            }
                            else if(country == "Canada")
                            {
                                $scope.provinces = canada;
                            }
                        
                        }
                        
                        function validateNumber(value)
                        {
                        var regex = /^[1-9]\d*(((,\d{3}){1})?(\.\d{0,2})?)$/;
                        if (regex.test(value))
                        {
                        //Input is valid, check the number of decimal places
                        var twoDecimalPlaces = /\.\d{2}$/g;
                        var oneDecimalPlace = /\.\d{1}$/g;
                        var noDecimalPlacesWithDecimal = /\.\d{0}$/g;
                        
                        if(value.match(twoDecimalPlaces ))
                        {
                        //all good, return as is
                        return value;
                        }
                        if(value.match(noDecimalPlacesWithDecimal))
                        {
                        //add two decimal places
                        return value+'00';
                        }
                        if(value.match(oneDecimalPlace ))
                        {
                        //ad one decimal place
                        return value+'0';
                        }
                        //else there is no decimal places and no decimal
                        return value+".00";
                        }
                        return null;
                        
                        }
                        
                        $scope.$on('$destroy', function() {
                                   resizeListener();
                                   menuIcon.style.borderBottom = "none";
                                   });
                        
                        
                        }])
.controller('MyCtrl4', ['$scope','$rootScope','myService','$timeout', function($scope,$rootScope,myService,$timeout) {
                        
                        var menuIcon = document.getElementById('settingsIcon');
                        menuIcon.style.borderBottom = "5px solid #78aedb";
                        var resizeListener = $rootScope.$watch('height',function(){                        
						document.getElementById('whiteBannerMenu').style.height = ($rootScope.height * 0.09) + 'px';
						document.getElementById('container').style.height = ($rootScope.height * (1-0.095)) + 'px';
                        document.documentElement.style.fontSize = ($rootScope.height * 0.03) + 'px';
						$scope.inputHeight = ($rootScope.height * 0.14) + 'px';
						document.getElementById('entirePage').style.height = 'auto';
                                          });
                        $scope.testMode = localStorage["testMode"];
                        $scope.storeId = localStorage["storeId"];
                        $scope.storePassword = localStorage["storePassword"];
                        
                        var watchStoreId = $scope.$watch('storeId', function(newValue, oldValue){
                                 if(newValue === oldValue) {return;}
                                 else
                                 {
                                     if(typeof $scope.cancelSaveText === "function"){$scope.cancelSaveText();}
                                     localStorage["storeId"] = $scope.storeId;
                                     $scope.txtSave = "Saving..";
                                     $scope.cancelSaveText = $timeout(function(){$scope.txtSave = "Saved"}, 2000);
                                 }
                            }, true);
                        var watchStorePassword = $scope.$watch('storePassword', function(newValue, oldValue){
                               if(newValue === oldValue) {return;}
                               else
                               {
                                   if(typeof $scope.cancelSaveText === "function"){$scope.cancelSaveText();}
                                   localStorage["storePassword"] = $scope.storePassword;
                                   $scope.txtSave = "Saving..";
                                   $scope.cancelSaveText = $timeout(function(){$scope.txtSave = "Saved"}, 2000);
                               }
                           }, true);
                        var watchTestMode = $scope.$watch('testMode', function(newValue,oldValue) {
                              if(newValue === oldValue) {return;}//otherwise runs automatically
                              else
                              {
                                  if(typeof $scope.cancelSaveText === "function"){$scope.cancelSaveText();}
                                  localStorage["testMode"] = $scope.testMode;
                                  $scope.txtSave = "Saving..";
                                  $scope.cancelSaveText = $timeout(function(){$scope.txtSave = "Saved"}, 2000);
                              }
                          }, true);
                        $scope.txtSave = "Save Settings";
                        
                        $scope.save = function()
                        {
                            if(typeof $scope.cancelSaveText === "function"){$scope.cancelSaveText();}
                            $scope.txtSave = "Saving..";
                            $scope.cancelSaveText = $timeout(function(){$scope.txtSave = "Saved"}, 2000);
                        }
                        
                        
                        //reader detection
						$scope.readerStatus = myService.readerStatus;
						$scope.$on('reader:updated',function(event,args) {
							$scope.readerStatus = myService.readerStatus;
							$scope.$apply();
						});
						
                        //var btnToggleReader = document.getElementById('btnToggleReader');

                        
                        $scope.toggleReader = function()
                        {
                            if(myService.isReaderConnected)
                            {
                                myService.deactivateSDK();
                            }
                            else
                            {
                                //btnToggleReader.disabled = true;
                                myService.activateSDK();
                            }
                        }
                        
                        $scope.$on('$destroy', function() {
                                   //destroy listeners because watch() returns a destroy function
                                   resizeListener();
                                   watchStoreId();
                                   watchStorePassword();
                                   watchTestMode();
                                   menuIcon.style.borderBottom = "none";
                                   });

                        
                        }])
.controller('MyCtrl5', ['$scope','$rootScope','dbService','$routeParams','myService','ajaxService','$route', function($scope,$rootScope,dbService,$routeParams,myService,ajaxService,$route) {
                        
                        var menuIcon = document.getElementById('ordersIcon');
                        menuIcon.style.borderBottom = "5px solid #78aedb";
                        //resize
                        var resizeListener = $rootScope.$watch('height',function(){
						document.getElementById('whiteBannerMenu').style.height = ($rootScope.height * 0.09) + 'px';
                        document.getElementById('container').style.height = ($rootScope.height * (1-0.095)) + 'px';
                        //document.getElementById('entirePage').style.height = height + 'px';
                        //document.getElementById('whiteBannerMenu').style.height = (height * 0.09) + 'px';
                        //elements[0].style.height = (height * 0.12) + 'px';
                        $scope.inputHeight = ($rootScope.height * 0.10) + 'px';
						document.documentElement.style.fontSize = ($rootScope.height * 0.03) + 'px';
                        //document.getElementById('btnRefund').style.height = (height * 0.085) + 'px';
                        $scope.rowHeight = ($rootScope.height * 0.14) + 'px';
						document.getElementById('entirePage').style.height = 'auto';
                        //document.documentElement.style.fontSize = (height * 0.03) + 'px';
                        //end resize
                                          });
                        
                        
                        myService.modalActivated = false;
                        $scope.modalFontSize = '1rem';
                        $scope.balance = 0.00;
                        $scope.preAuthAmount = 0.00;
                        $scope.showPostAuth = false;
                        $scope.orderId = $routeParams.orderId;
                        var sqlString = "select t.time,t.subTotal,t.action,t.status,o.orderId,o.customerName,o.phone,o.email,o.address,o.province,o.city,o.country,o.postal,o.avsResponse,o.refNum,o.cvvResult,o.notes from transactions as t join orders as o on o.orderid = t.orderid where o.orderId = '" + $scope.orderId + "'";
                        
                        dbService.queryDB2(sqlString)
                        .then(function(results) {
                              $scope.transactions = results;
                              
                              //shows the post auth button only if none of the transactions are type Post-Auth.
                              //calculate balance
                              var showPostAuth = false;
                              var length = results.length;
                              for(var i = 0;i<length;i++)
                              {
                              if(results[i].action == "Pre-Auth")
                              {
                              showPostAuth = true;
                              }
                              else if(results[i].action == "Post-Auth")
                              {
                              $scope.balance += results[i].subTotal;
                              showPostAuth = false;
                              }
                              else if(results[i].action == "Sale")
                              {
                              $scope.balance += results[i].subTotal;
                              }
                              else if(results[i].action == "Refund")
                              {
                              $scope.balance -= results[i].subTotal;
                              }
                              }
                              if(showPostAuth) { $scope.showPostAuth = true; $scope.preAuthAmount = results[0].subTotal; }
                              
                              }, function(result) {
                              navigator.notification.alert('Error loading order.',null,'Oops','Continue');
                              });
                        
                        $scope.cancelModal = function(action) { myService.toggleModal(action);};
                        
                        $scope.postAuth = function()
                        {
						
							if(localStorage["testMode"] == "on")
							{
								navigator.notification.alert('Post-Auths are unavailable in test mode. If this was a live transaction, disable test mode and retry.',null,'Oops','Ok');
							}
							else
							{
							myService.toggleModal('process');
							navigator.notification.prompt(
                                                      'Charge amount:',  // message
                                                      postAuth,                  // callback to invoke
                                                      'Post-Auth',            // title
                                                      ['Ok','Cancel'],             // buttonLabels
                                                      ''                 // defaultText
                                                      );
							}
                        }
                        
                    function postAuth(result)
                    {
                        
                        if(result.buttonIndex == 1)
                        {
                        var chargeAmount = validateNumber(result.input1);
                        
                        if(chargeAmount)
                        {
                        if($scope.transactions[0].subTotal >= chargeAmount)
                        {
                        navigator.notification.confirm('Charge this card for $' + chargeAmount + '?',function(buttonIndex) {
					    if(buttonIndex == 1)
					    {
							//refund is valid
						    if(localStorage["testMode"] == "on")
							{
								var xmlString = "<Order>"
							+"<OrderID>" + $scope.transactions[0].orderId + "</OrderID>"
							+"<StoreID>" + "teststore" + "</StoreID>"
							+"<Passphrase>" + "psigate1234" + "</Passphrase>"
							+"<PaymentType>" + "CC" + "</PaymentType>"
							+"<CardAction>" + "2" + "</CardAction>"
							+"<SubTotal>" + chargeAmount + "</SubTotal>"
							+ "</Order>";
								var isLive = false;
							}
							else
							{
								var isLive = true;
								var xmlString = "<Order>"
							+"<OrderID>" + $scope.transactions[0].orderId + "</OrderID>"
							+"<StoreID>" + localStorage['storeId'] + "</StoreID>"
							+"<Passphrase>" + localStorage['storePassword'] + "</Passphrase>"
							+"<PaymentType>" + "CC" + "</PaymentType>"
							+"<CardAction>" + "2" + "</CardAction>"
							+"<SubTotal>" + chargeAmount + "</SubTotal>"
							+ "</Order>";
							}
							
							ajaxService.purchaseRequest(xmlString,isLive)
							.then(function(response) {
								  if($(response).find('Approved').text() == "APPROVED")
								  {
								  var newTransaction = {};
								  newTransaction.time = new Date($(response).find('TransTime').text()); //Date() object created from TransTime
								  newTransaction.orderId = $scope.transactions[0].orderId;
								  newTransaction.authAmount = chargeAmount;
								  newTransaction.cardAction = 2;
								  newTransaction.status = "APPROVED";
								  
								  //order.orderId,order.authAmount,order.time,order.cardAction,order.status
								  var sqlString = 'INSERT INTO TRANSACTIONS (orderId, subTotal, time, action, status) VALUES (?,?,?,?,?)';
								  dbService.newTransaction(sqlString,newTransaction)
								  .then(function(response) {
										//success for transaction db
										$route.reload();
										},function(response) {
										//fail response from db
										navigator.notification.alert('Error while entering transaction in database.',null,'Oops','Continue');
										myService.toggleModal('process');
										});
								  }
								  else
								  {
								  navigator.notification.alert('Transaction not successful: ' + $(response).find('ErrMsg').text(),null,'Oops','Continue');
								  myService.toggleModal('process');
								  }
								  }, function(response) {
								  navigator.notification.alert('Error receiving AJAX response.',null,'Oops','Continue');
								  myService.toggleModal('process');
								  });
                        }
					    else
					    {
					    chargeAmount = 0;
					    myService.toggleModal('process');
					    }
                                                       
                                                       
                            },'Are you sure?',['Continue','Cancel']);
                        }
                        else
                        {
                        navigator.notification.alert('Charge cannot exceed pre-auth amount.',null,'Oops','Continue');
                        myService.toggleModal('process');
                        }
                        }
                        else
                        {
                        navigator.notification.alert('Invalid charge amount.',null,'Oops','Continue');
                        myService.toggleModal('process');
                        }
                        }
                        }
                        
                        $scope.refund = function()
                        {
						if(localStorage["testMode"] == "on")
                        {
							navigator.notification.alert('Refunds are unavailable in test mode. If this was a live transaction, disable test mode and retry.',null,'Oops','Ok');
						}
						else
						{
							myService.toggleModal('process');
							navigator.notification.prompt(
														  'Refund amount:',  // message
														  refund,                  // callback to invoke
														  'Refund',            // title
														  ['Ok','Cancel'],             // buttonLabels
														  ''                 // defaultText
														  );
							};
						
						}
							
									
								
                        
                    function refund(result)
                    {
                        
                        if(result.buttonIndex == 1)
                        {
                        
                        var refundAmount = validateNumber(result.input1);
                        
                        if(refundAmount)
                        {
                        if($scope.balance >= refundAmount)
                        {
                        navigator.notification.confirm('Complete the refund of $' + refundAmount + '?',function(buttonIndex) {
                                   if(buttonIndex == 1)
                                   {
                                       //refund is valid
									   if(localStorage["testMode"] == "on")
										{
											var xmlString = '<Order><StoreID>teststore</StoreID><Passphrase>psigate1234</Passphrase><Subtotal>' + refundAmount + '</Subtotal><CardAction>3</CardAction><PaymentType>CC</PaymentType><OrderID>' + $scope.transactions[0].orderId + '</OrderID></Order>';
											var isLive = false;
										}
										else
										{
											var isLive = true;
											var xmlString = '<Order><StoreID>'+localStorage["storeId"] + '</StoreID><Passphrase>' + localStorage["storePassword"] + '</Passphrase><Subtotal>' + refundAmount + '</Subtotal><CardAction>3</CardAction><PaymentType>CC</PaymentType><OrderID>' + $scope.transactions[0].orderId + '</OrderID></Order>';
										}
                                       
                                       ajaxService.purchaseRequest(xmlString,isLive)
                                       .then(function(response) {
                                             
                                             if($(response).find('Approved').text() == "APPROVED")
                                             {
                                             var newTransaction = {};
                                             newTransaction.time = new Date($(response).find('TransTime').text()); //Date() object created from TransTime
                                             newTransaction.orderId = $scope.transactions[0].orderId;
                                             newTransaction.authAmount = refundAmount;
                                             newTransaction.cardAction = 3;
                                             newTransaction.status = "APPROVED";
                                             
                                             //order.orderId,order.authAmount,order.time,order.cardAction,order.status
                                             var sqlString = 'INSERT INTO TRANSACTIONS (orderId, subTotal, time, action, status) VALUES (?,?,?,?,?)';
                                             dbService.newTransaction(sqlString,newTransaction)
                                             .then(function(response) {
                                                   //success for transaction db
                                                   $route.reload();
                                                   },function(response) {
                                                   //fail response from db
                                                   navigator.notification.alert('Error while entering transaction in database.',null,'Oops','Continue');
                                                   myService.toggleModal('process');
                                                   });
                                             }
                                             else
                                             {
                                             navigator.notification.alert('Transaction not successful: ' + $(response).find('ErrMsg').text(),null,'Oops','Continue');
                                             myService.toggleModal('process');
                                             }
                                             }, function(response) {
                                             navigator.notification.alert('Error receiving AJAX response.',null,'Oops','Continue');
                                             myService.toggleModal('process');
                                             });
                                   }
                                   else
                                   {
                                        refundAmount = 0;
                                        myService.toggleModal('process');
                                   }
                                                       
                                                       
                               },'Are you sure?',['Continue','Cancel']);
                        
                        }
                        else
                        {
                        navigator.notification.alert('Refunds cannot exceed sale amount.',null,'Oops','Continue');
                        myService.toggleModal('process');
                        }
                        }
                        else
                        {
                        navigator.notification.alert('Invalid refund amount.',null,'Oops','Continue');
                        myService.toggleModal('process');
                        }
                        }
                        };
                        
                        function validateNumber(value) 
                        {
                        var regex = /^[1-9]\d*(((,\d{3}){1})?(\.\d{0,2})?)$/;
                        if (regex.test(value))
                        {
                        //Input is valid, check the number of decimal places
                        var twoDecimalPlaces = /\.\d{2}$/g;
                        var oneDecimalPlace = /\.\d{1}$/g;
                        var noDecimalPlacesWithDecimal = /\.\d{0}$/g;
                        
                        if(value.match(twoDecimalPlaces ))
                        {
                        //all good, return as is
                        return value;
                        }
                        if(value.match(noDecimalPlacesWithDecimal))
                        {
                        //add two decimal places
                        return value+'00';
                        }
                        if(value.match(oneDecimalPlace ))
                        {
                        //ad one decimal place
                        return value+'0';
                        }
                        //else there is no decimal places and no decimal
                        return value+".00";
                        }
                        return null;
                        
                        }
                        
                        $scope.$on('$destroy', function() {
                                   resizeListener();
                                   menuIcon.style.borderBottom = "none";
                                   });
                        
                        }]);
