'use strict';


// Declare app level module which depends on filters, and services
angular.module('myApp', [
  'ngRoute',
  'ngTouch',
  'myApp.filters',
  'myApp.services',
  'myApp.directives',
  'myApp.controllers'
]).
run(['$rootScope','$window', function($rootScope,$window) {
     $rootScope.width = $(window).width();
     $rootScope.height = $(window).height();
     angular.element($window).bind('orientationchange',function(){
       if($rootScope.width != $(window).width())
	   {
		   $rootScope.width = $(window).width();
		   $rootScope.height = $(window).height();
			if($rootScope.height < 475)
					   {
					   $rootScope.height = 475;
					   }
					   //$rootScope.$apply('height');
		   $rootScope.$digest();
		   FastClick.attach(document.body);
		}
       
    });
}]).
config(['$routeProvider', function($routeProvider) {
  $routeProvider.when('/view1', {templateUrl: 'partials/partial1.html', controller: 'MyCtrl1'});
  $routeProvider.when('/view2', {templateUrl: 'partials/partial2.html', controller: 'MyCtrl2'});
  $routeProvider.when('/view3', {templateUrl: 'partials/partial3.html', controller: 'MyCtrl3'});
  $routeProvider.when('/view4', {templateUrl: 'partials/partial4.html', controller: 'MyCtrl4'});
  $routeProvider.when('/view5/:orderId', {templateUrl: 'partials/partial5.html', controller: 'MyCtrl5'});
  $routeProvider.otherwise({redirectTo: '/view1'});
}]);
