function submitXmlSale() 
{ //submits an xml form to psigate and returns object.success(boolean) object.response(xml response)
	if(document.getElementById('inputCardNum').value.length == 16)
	{
        if(document.getElementById('inputCvv').value != '')
        {
            if(!isNaN(document.getElementById('inputAmount').value))
            {
		document.getElementById('openModalProcessing').style.opacity = 1;
		document.getElementById('openModalProcessing').style.pointerEvents = 'auto';
		var xml = buildXmlSalesForm();
		//basic order
		//var xml = '<Order><StoreID>teststore</StoreID><Passphrase>psigate1234</Passphrase><OrderID>' + encodeURI("kev221114 33342") + '</OrderID><Subtotal>10.00</Subtotal><CardAction>0</CardAction><Bname>test&#032;testing</Bname><PaymentType>CC</PaymentType><CardNumber>4111111111111111</CardNumber><CardExpMonth>02</CardExpMonth><CardExpYear>08</CardExpYear><CardIDNumber>3422</CardIDNumber></Order>';
		//detailed order
		//var xml = '<Order><StoreID>teststore</StoreID><Passphrase>psigate1234</Passphrase><Bname>John Smith</Bname><Bcompany>PSiGate</Bcompany><Baddress1>123 Main St.</Baddress1><Baddress2>Apt 6</Baddress2><Bcity>Toronto</Bcity><Bprovince>Ontario</Bprovince><Bpostalcode>L5N2B3</Bpostalcode><Bcountry>Canada</Bcountry><Phone>416-555-2092</Phone><Fax>416-555-2091</Fax><Email>someone@somewhere.com</Email><Comments>No comments today</Comments><Tax1>5.00</Tax1><ShippingTotal>5.00</ShippingTotal><Subtotal>10.00</Subtotal><PaymentType>CC</PaymentType><CardAction>0</CardAction><CardNumber>4111111111111111</CardNumber><CardExpMonth>02</CardExpMonth><CardExpYear>08</CardExpYear><CardIDNumber>3422</CardIDNumber></Order>';
		 $.ajax({ 
			type: "POST",
			url: "https://dev.psigate.com:7989/Messenger/XMLMessenger",
			data: { "orderXML":xml },
			crossDomain: true,
			dataType: "xml",
			error: function() { alert("Error: Server did not respond.");document.getElementById('openModalProcessing').style.opacity = 0;document.getElementById('openModalProcessing').style.pointerEvents = 'none';},
			success: function(response) { receiveTransactionResponse(response,"Sale"); }
		});
	}
            else
            {
                alert('Purchase amount can only be numbers');
                document.getElementById('inputAmount').focus();
            }
        }
        else
        {
            alert('CVV is required');
            document.getElementById('inputCvv').focus();
        }
        }
	else
	{
		document.getElementById('inputCardNum').focus();
		alert('Credit card number is invalid');
	}
}
		
function submitXmlRefund() 
{ //submits an xml form to psigate and returns object.success(boolean) object.response(xml response)
	var refundAmount = validateNumber(prompt("Refund amount:"));
	if(refundAmount)
	{
		document.getElementById('openModalProcessing').style.opacity = 1;
		document.getElementById('openModalProcessing').style.pointerEvents = 'auto';
		if(balance >= refundAmount)
		{
			var orderId = document.getElementById('saleOrderId').innerText;
			if(refundAmount.length == 0)
			{
				alert('Refund amount invalid. Examples: "20.00", or "15.99". \nTry again by pressing the Refund button.');
			}
			else
			{
				//var xml = buildXmlString();
				//basic order
				var xml = '<Order><StoreID>teststore</StoreID><Passphrase>psigate1234</Passphrase><Subtotal>' + refundAmount + '</Subtotal><CardAction>3</CardAction><PaymentType>CC</PaymentType><OrderID>' + orderId + '</OrderID></Order>';
				//detailed order
				//var xml = '<Order><StoreID>teststore</StoreID><Passphrase>psigate1234</Passphrase><Bname>John Smith</Bname><Bcompany>PSiGate</Bcompany><Baddress1>123 Main St.</Baddress1><Baddress2>Apt 6</Baddress2><Bcity>Toronto</Bcity><Bprovince>Ontario</Bprovince><Bpostalcode>L5N2B3</Bpostalcode><Bcountry>Canada</Bcountry><Phone>416-555-2092</Phone><Fax>416-555-2091</Fax><Email>someone@somewhere.com</Email><Comments>No comments today</Comments><Tax1>5.00</Tax1><ShippingTotal>5.00</ShippingTotal><Subtotal>10.00</Subtotal><PaymentType>CC</PaymentType><CardAction>0</CardAction><CardNumber>4111111111111111</CardNumber><CardExpMonth>02</CardExpMonth><CardExpYear>08</CardExpYear><CardIDNumber>3422</CardIDNumber></Order>';
				 $.ajax({ 
					type: "POST",
					url: "https://dev.psigate.com:7989/Messenger/XMLMessenger",
					data: { "orderXML":xml },
					crossDomain: true,
					dataType: "xml",
					error: function() { alert("Error: Server did not respond.");document.getElementById('openModalProcessing').style.opacity = 0;document.getElementById('openModalProcessing').style.pointerEvents = 'none';},
					success: function(response) { receiveTransactionResponse(response, "Refund"); }
				});
			}
		}
		else
		{
			alert("Error: Refunds cannot exceed the sale amount.");
			document.getElementById('openModalProcessing').style.opacity = 0;
			document.getElementById('openModalProcessing').style.pointerEvents = 'none';
		}
	}
	else
	{
		alert("Invalid refund amount");
	}
	
}

function receiveTransactionResponse(response,transType)
{
	if($(response).find('Approved').text() == 'APPROVED')
	{
		dbMerchantApp = window.openDatabase("dbMerchantApp", "1.0", "Merchant App DB",1000000);
		var transTime = new Date($(response).find('TransTime').text()); //Date() object created from TransTime
		callback = 0;
		if(transType == 'Sale')
		{
			var newOrder = JSON.parse(window.localStorage.getItem("newOrder"));
			newOrder.status = $(response).find('Approved').text();
			newOrder.avsResponse = $(response).find('AVSResult').text();
			newOrder.refNum = $(response).find('TransRefNumber').text();
			newOrder.cvvResult = $(response).find('CardIDResult').text();
			newOrder.authAmount = $(response).find('SubTotal').text();
			newOrder.time = transTime.getTime(); // converts to int, number of seconds since some day in 1970 (standard unit of time measurement. easily convertable)
			newOrder.transType = transType;
			dbMerchantApp.transaction( function(tx) { 
				var sqlString = 'INSERT INTO ORDERS (orderId,customerName,email,city,phone,province,country,address,postal,subTotal,time,notes,avsResponse,refNum,cvvResult) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)';
				insertNewSale(tx,sqlString,newOrder);
				sqlString = 'INSERT INTO TRANSACTIONS (orderId, subTotal, time, action, status) VALUES (?,?,?,?,?)';
				insertTransaction(tx,sqlString,newOrder);
				});
		}
		else //if transType == Refund
		{
			callback = 1;
			//orderId, authAmount, time, refundAmount, customerName, email, address, city, province, country, phone, postalcode, transType, status
			var orderId = $(response).find('OrderID').text();
			var status = $(response).find('Approved').text();
			var authAmount = $(response).find('SubTotal').text();
			var time = transTime.getTime();
			var newOrder = new Order(orderId,authAmount,time,'','','','','','','','','',transType,status);
			dbMerchantApp.transaction( function(tx) { 
				var sqlString = 'INSERT INTO TRANSACTIONS (orderId, subTotal, time, action, status) VALUES (?,?,?,?,?)';
				insertTransaction(tx,sqlString,newOrder);
			});
		}
	}
	else
	{
		alert('Error on Ajax Response: ' + $(response).find('ErrMsg').text());
		document.getElementById('openModalProcessing').style.opacity = 0;
		document.getElementById('openModalProcessing').style.pointerEvents = 'none';
	}	
}
//('INSERT INTO ORDERS (orderId, authAmount, refundAmount, customerName,authTime,refundTime
function Order(orderId, authAmount, time, refundAmount, customerName, email, address, city, province, country, phone, postal, transType, status, notes,avsResponse,refNum,cvvResult) {
  this.orderId = orderId;
  this.customerName = customerName;
  this.authAmount = authAmount;
  this.time = time;
  this.refundAmount = refundAmount;
  this.email = email;
  this.address = address;
  this.city = city;
  this.province = province;
  this.country = country;
  this.phone = phone;
  this.postal = postal;
  this.transType = transType;
  this.status = status;
  this.notes = notes;
  this.avsResponse = avsResponse;
  this.refNum = refNum;
  this.cvvResult = cvvResult;
}


function alertPaymentApproved()
{
	navigator.notification.alert(
		'Payment Approved',  // message
		function() { document.location.href = 'index.html';},         // callback
		'Payment Approved',            // title
		'Ok'                  // buttonName
	);
}

function buildXmlSalesForm() // returns xml form as string with fields encoded 
{
    var d = new Date();
    var month = "0" + d.getMonth();
    var day = "0" + d.getDate();
    var hour = "0" + d.getHours();
    var minute = "0" + d.getMinutes();
    var second = "0" + d.getSeconds();
    var orderId = d.getFullYear().toString().slice(-2) + month.slice(-2) + day.slice(-2) + hour.slice(-2) + minute.slice(-2) + second.slice(-2);
    //var newOrder = JSON.parse(window.localStorage.getItem("newOrder"));  DEPRECATED
	var newOrder = new Order(orderId,document.getElementById('inputAmount').value,"","",document.getElementById('inputCustomer').value,document.getElementById('inputEmail').value,document.getElementById('inputAddress').value,document.getElementById('inputCity').value,document.getElementById('inputProvince').value,document.getElementById('inputCountry').value,document.getElementById('inputPhone').value,document.getElementById('inputPostal').value,"","",document.getElementById('inputOrderNotes').value,"","","");
    var formFields = [];
	var xmlString = "<Order>";
    formFields.push("<OrderID>" + orderId + "</OrderID>");
	//customer details (optional)
	formFields.push("<Bname>" + encodeURI(newOrder.customerName) + "</Bname>");
	formFields.push("<Email>" + newOrder.email + "</Email>");
	formFields.push("<Baddress1>" + newOrder.address + "</Baddress1>");
	formFields.push("<Bcity>" + encodeURI(newOrder.city) + "</Bcity>");
	formFields.push("<Bprovince>" + encodeURI(newOrder.province) + "</Bprovince>");
	formFields.push("<Bpostalcode>" + encodeURI(newOrder.postal) + "</Bpostalcode>");
	formFields.push("<Bcountry>" + encodeURI(newOrder.country) + "</Bcountry>");
	formFields.push("<Phone>" + encodeURI(newOrder.phone) + "</Phone>");
	//card and transaction details (required)
	formFields.push("<StoreID>" + "teststore" + "</StoreID>");
	formFields.push("<Passphrase>" + "psigate1234" + "</Passphrase>");
	formFields.push("<PaymentType>" + "CC" + "</PaymentType>");
	formFields.push("<CardAction>" + "0" + "</CardAction>");
	formFields.push("<Subtotal>" + document.getElementById("inputAmount").value + "</Subtotal>");
	formFields.push("<CardNumber>" + document.getElementById("inputCardNum").value + "</CardNumber>");
	formFields.push("<CardExpMonth>" + document.getElementById("selectExpMonth").value + "</CardExpMonth>");
	formFields.push("<CardExpYear>" + document.getElementById("selectExpYear").value + "</CardExpYear>");
	formFields.push("<CardIDNumber>" + document.getElementById("inputCvv").value + "</CardIDNumber>");
	
	for (i=0;i<formFields.length;i++)
	{
		xmlString += formFields[i];
	}
	xmlString += "</Order>";
	window.localStorage.setItem("newOrder", JSON.stringify(newOrder));
	
	return xmlString;
}

//orderId, authAmount, time, refundAmount, customerName, email, address, city, province, country, phone, postalcode, transType, status
function saveData()
{
	var name = document.getElementById('name').value;
	var email = document.getElementById('email').value;
	var address = document.getElementById('address').value;
	var city = document.getElementById('city').value;
	var province = document.getElementById('province').value;
	var country = document.getElementById('country').value;
	var phone = document.getElementById('phone').value;
	var postalcode = document.getElementById('postalcode').value;
	var newOrder = new Order("","","","",name,email,address,city,province,country,phone,postalcode,"","");
	window.localStorage.setItem("newOrder", JSON.stringify(newOrder));
}